<?php


/**
 * Class SmartBtnRouter
 */
class SmartBtnRouter

{
    /**
     * @var
     */
    private $request;
    /**
     * @var false|mixed
     */
    private $newToken;
    /**
     * @var
     */
    private $data;
    /**
     * @var SmartBtn
     */
    private $smartbtn;

    /**
     * SmartBtnRouter constructor.
     * @param $request
     */
    public function __construct($request)
    {
        $this->request = $request;
        $this->newToken = $this->set_token_check();
        $this->smartbtn = new SmartBtn();
        $this->sign_out();
        $this->decode();
    }

    /**
     * @return false|mixed
     */
    private function set_token_check()
    {
        return $this->request['sma_token'] ?? false;
    }

    /**
     *
     */
    private function decode()
    {
        if ($this->newToken) {
            $decoder = new SmartBtnDecoder($this->newToken);
            $this->data = $decoder->get_data();
            if ($this->smartbtn->set_new_token($this->data)) {
                $this->smartbtn->set_registered();
            }
        }
    }

    /**
     *
     */
    private function sign_out()
    {
        if(isset($this->request['sign_out_btn'])) {
            $this->smartbtn->set_signed_out();
        }
    }

    /**
     * @return false|string|string[]
     */
    public function get_result()
    {
        return $this->smartbtn->get_view();
    }


}


