<?php


/**
 * Class SmartBtn
 */
class SmartBtn
{
    /**
     * @var false|mixed|void
     */
    private $data;
    /**
     * @var mixed
     */
    private $host;
    /**
     * @var mixed
     */
    private $id;
    private $token;
    private $registered = false;
    private $notification = null;
    private $validToken = false;
    private $signOut =false;


    public function __construct()
    {
        $this->data = $this->get_option();
        $this->host = $this->get_host();
        $this->id = $this->get_id();
        $this->token = $this->get_token();
        $this->registered = $this->check_registered();
    }


    private function get_option()
    {
        return get_option(SMARTBTN__PLUGIN_TOKEN_OPTION);
    }

    private function get_token()
    {
        return $this->data['token'];
    }

    private function get_host()
    {
        return $this->data['host'];
    }

    private function get_id()
    {
        return $this->data['id'];
    }

    private function check_registered()
    {
        if ($this->data) {
            return true;
        }
        return $this->data;
    }

    private function check_token($data)
    {
        if(!is_numeric($data["id"])) { return false; }

        $url = $data["host"] . '/logintoken';
        $fields = array(
            'api_token' => $data["token"],
        );
        $context = stream_context_create(
            array(
                'http' => array(
                    'method' => 'POST',
                    'header' => 'Content-type: application/x-www-form-urlencoded',
                    'content' => http_build_query($fields),
                )
            )
        );

        @$response = json_decode(file_get_contents($url, false, $context));

        if ($response->istoken) {
            return true;
        }
        return false;
    }

    public function get_view()
    {
        if ($this->registered && $this->check_token($this->data)) {
            $view = file_get_contents(SMARTBTN__PLUGIN_VIEW_PATH . 'sma_chat_page.php');
            $view = str_replace(['{ID}', '{HOST}', '{TOKEN}', '{ASSET}'], [$this->id, $this->host, $this->token, str_replace('/api', '', $this->host)], $view);
            return $view;
        } else {
            return str_replace('{NOTIFICATION}', $this->notification, file_get_contents(SMARTBTN__PLUGIN_VIEW_PATH . 'sma_input_token.php'));
        }
    }

    public function set_new_token(array $data)
    {
        if ($this->check_token($data)) {
            update_option(SMARTBTN__PLUGIN_TOKEN_OPTION, $data);
            $this->validToken = true;
            return true;
        }
        $this->notification = SmartBtnNotificator::show_error(SMARTBTN__PLUGIN_ERROR_TOKEN);
        return false;
    }

    public function set_registered()
    {
        $this->data = $this->get_option();
        $this->host = $this->get_host();
        $this->id = $this->get_id();
        $this->token = $this->get_token();
        $this->registered = $this->check_registered();
    }

    public function set_signed_out()
    {
        if(delete_option(SMARTBTN__PLUGIN_TOKEN_OPTION)){
            $this->signOut = true;
            $this->registered = false;
            $this->data = false;
        }
    }
}
